using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;
using BlockDefense.Classes;

namespace BlockDefense
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class BlockDefense : Microsoft.Xna.Framework.Game
    {
        public GraphicsDeviceManager    Graphics    { get; private set; }
        public SpriteBatch              SpriteBatch { get; private set; }
        public GameLibrary              Library     { get; private set; }
        
        public BlockDefense()
        {
            Graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
            Library = new GameLibrary();
        }
        protected override void Initialize()
        {
            Library.Initialize();
            base.Initialize();
        }
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            SpriteBatch = new SpriteBatch(GraphicsDevice);

            Library.LoadContent(Content);
        }
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (Library.Quit)
                this.Exit();

            Library.Update(gameTime, Window.ClientBounds);

            base.Update(gameTime);
        }
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.Black);
            SpriteBatch.Begin(SpriteBlendMode.AlphaBlend, SpriteSortMode.Immediate, SaveStateMode.SaveState);
            Library.Draw(gameTime, SpriteBatch);
            SpriteBatch.End();
            base.Draw(gameTime);
        }
    }
}
