﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

namespace BlockDefense.Classes
{
    public class Asteroid : Sprite
    {
        public bool     Slowed      { get; set; }
        public bool     OutOfBounds { get; private set; }
        public float    Speed       { get; set; }

        public Asteroid(Texture2D texture, Vector2 location, float speed ) : base(texture, location)
        {
            Speed = speed;
            Depth = .5f;
            Slowed = false;
        }
        public override void Update(GameTime gameTime, Rectangle clientBounds)
        {
            if (Slowed)
                Location.X += .5f * Speed;
            else
                Location.X += Speed;
            if (Location.X < -Texture.Width || Location.X > clientBounds.Width + Texture.Width)
                OutOfBounds = true;

            Bounds.X = (int)Location.X;
            base.Update(gameTime, clientBounds);
        }
        public override void Draw(GameTime gameTime, SpriteBatch spriteBatch)
        {
            base.Draw(gameTime, spriteBatch);
        }
        public override bool Equals(object obj)
        {
            return base.Equals(obj);
        }
        public override int GetHashCode()
        {
            return base.GetHashCode();
        }

    }
}
