﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

namespace BlockDefense.Classes
{
    public class Defender : Sprite
    {
        public Defender(Texture2D texture, Vector2 location, float depth) : base(texture, location, depth)
        {

        }

        public override void Update(GameTime gameTime, Rectangle clientBounds)
        {
            if (GamePad.GetState(PlayerIndex.One).ThumbSticks.Left.Y > 0)
                Location.Y = MathHelper.Clamp(Location.Y - 10, 37, clientBounds.Height - 20 - Texture.Height);
            else if (GamePad.GetState(PlayerIndex.One).ThumbSticks.Left.Y < 0)
                Location.Y = MathHelper.Clamp(Location.Y + 10, 37, clientBounds.Height - 37 - Texture.Height);

            Bounds.Y = (int)Location.Y;

            base.Update(gameTime, clientBounds);
        }
        public override void Draw(GameTime gameTime, SpriteBatch spriteBatch)
        {
            base.Draw(gameTime, spriteBatch);
        }
        public override bool Equals(object obj)
        {
            return base.Equals(obj);
        }
        public override int GetHashCode()
        {
            return base.GetHashCode();
        }
    }
}
